# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define namedreltag %{nil}
%global namedversion %{version}%{?namedreltag}

%define section free

Name:           sisu-cglib
Version:        2.2.2
Release:        1%{?dist}
Epoch:          0
Summary:        Sisu CGLIB
License:        ASL 2.0
URL:            http://sonatype.org
Group:          Development/Libraries/Java
%if 0
git clone https://github.com/sonatype/sisu-cglib.git && cd sisu-cglib && git archive --prefix="sisu-cglib-2.2.2/" --format=tar cglib-2.2.2 | bzip2 -9 > ../sisu-cglib-2.2.2.tar.bz2
%endif
Source0:        sisu-cglib-2.2.2.tar.bz2
Patch0:         sisu-cglib-pom-versions.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       ant >= 0:1.8.2
Requires:       objectweb-asm >= 0:3.3.1
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  ant >= 0:1.8.2
BuildRequires:  objectweb-asm >= 0:3.3.1
BuildRequires:  junit4 >= 0:4.8.2
# XXX: 9
BuildRequires:  forge-parent >= 0:5
%if 0
BuildRequires:  maven-compiler-plugin >= 0:2.3.2
BuildRequires:  maven-javadoc-plugin >= 0:2.7
# XXX: 2.1
BuildRequires:  maven-release-plugin >= 0:2.0
# XXX: 3.0-beta-3
BuildRequires:  maven-site-plugin >= 0:2.2
BuildRequires:  maven-source-plugin >= 0:2.1.2
# XXX: 2.7.2
BuildRequires:  maven-surefire-plugin >= 0:2.3.1
%else
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
CGLIB Cloned from :pserver:anonymous@cglib.cvs.sourceforge.net:/cvsroot/cglib
and re-organized into Maven build.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if 0
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p maven2-brew/org/sonatype/sisu/inject/cglib/%{namedversion}/cglib-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/cglib-%{namedversion}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p maven2-brew/org/sonatype/sisu/inject/cglib/%{namedversion}/cglib-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-cglib.pom

# depmaps
%add_to_maven_depmap org.sonatype.sisu.inject cglib %{namedversion} JPP/%{name} cglib

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if 0
# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -pr target/target/site/* %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc README
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/cglib-%{namedversion}.jar
%{_javadir}*/%{name}/cglib.jar
%{_datadir}/maven2/poms/JPP.%{name}-cglib.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if 0
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{namedversion}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Sep 20 2011 David Walluck <dwalluck@redhat.com> 0:2.2.2-1
- release
